Option Strict Off
Option Explicit On 

module  TeleTokenAPI

    Public Declare Function GetTickCount Lib "kernel32.dll" Alias "GetTickCount" () As Integer
    Public Declare Sub SetLastError Lib "kernel32.dll" (ByVal ErrNum As Integer)
    Public Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Long, ByVal phkResult As Long, ByVal lpdwDisposition As Long) As Long
    Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByVal lpType As Long, ByVal lpData As ValueType, ByVal lpcbData As Long) As Long
    Public Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpData() As Byte, ByVal cbData As Long) As Long
    Public Declare Function RegCloseKey Lib "advapi32.dll" Alias "RegCloseKey" (ByVal hKey As Long) As Long

    Const REG_BINARY As Long = 3
    Const REG_OPTION_NON_VOLATILE As Long = 0
    Const REG_OPENED_EXISTING_KEY As Long = 2
    Const HKEY_CURRENT_USER As Long = &H80000001
    Const HKEY_LOCAL_MACHINE As Long = &H80000002
    Const HKEY_USERS As Long = &H80000003
    Const HKEY_CURRENT_CONFIG As Long = &H80000005
    Const HKEY_DYN_DATA As Long = &H80000006

    Const KEY_ALL_ACCESS As Long = &HF003F
    Const KEY_CREATE_LINK As Long = &H20
    Const KEY_CREATE_SUB_KEY As Long = &H4
    Const KEY_ENUMERATE_SUB_KEYS As Long = &H8
    Const KEY_EXECUTE As Long = &H20019
    Const KEY_NOTIFY As Long = &H10
    Const KEY_QUERY_VALUE As Long = &H1
    Const KEY_READ As Long = &H20019
    Const KEY_SET_VALUE As Long = &H2
    Const KEY_WRITE As Long = &H20006

    Const TVTTAPI_Int_Name As String = "Software\\App Data\\Seed"
    Const TVTTAPI_INT_CON_SIZE = 1104

    Public Const ERROR_TOO_MANY_OPEN_FILES As Integer = 4
    Public Const ERROR_UNKNOWN_PORT As Integer = 1796
    Public Const ERROR_TIMEOUT As Integer = 1460
    Public Const ERROR_ACCOUNT_EXPIRED As Integer = 1793
    Public Const ERROR_ALREADY_INITIALIZED As Integer = 1247
    Public Const ERROR_UNEXP_NET_ERR As Integer = 59
    Public Const ERROR_GEN_FAILURE As Integer = 31
    Public Const ERROR_NOT_SUPPORTED As Integer = 50
    Public Const ERROR_INVALID_BLOCK As Integer = 1106
    Public Const ERROR_SET_NOT_FOUND As Integer = 1170
    Public Const ERROR_INVALID_PASSWORD As Integer = 86
    Public Const ERROR_ACCESS_DENIED As Integer = 5
    Public Const ERROR_COUNTER_TIMEOUT As Integer = 1121
    Public Const ERROR_NOT_FOUND As Integer = 1168
    Public Const ERROR_SUCCESS As Integer = 0
    Public Const ERROR_CRC As Integer = 23
    Public Const ERROR_INVALID_DATA As Integer = 13

    Const WM_KEYUP As Integer = &H101
    Const WM_KEYDOWN As Integer = &H100
    Const WM_MOUSEMOVE As Integer = &H200
    Const WM_LBUTTONDOWN As Integer = &H201
    Const WM_LBUTTONUP As Integer = &H202
    Const WM_MBUTTONDOWN As Integer = &H207
    Const WM_MBUTTONUP As Integer = &H208
    Const WM_RBUTTONDOWN As Integer = &H204
    Const WM_RBUTTONUP As Integer = &H205

    Public Class CTVTTAPI_INT_CON
        Public Data(TVTTAPI_INT_CON_SIZE) As Byte

        Public Sub Free()
            ZeroMemory(Data, TVTTAPI_INT_CON_SIZE, 0)
        End Sub
        '*****************************************************************************
        'Metoda prywatna zwracajca pojedynczy element tablicy Rand
        'Dostp z zewntrz poprzez property Rand[]
        '*****************************************************************************
        Function GetRand(ByVal Index As Integer) As Byte
            GetRand = Data(Index)
        End Function

        '*****************************************************************************
        'Metoda prywatna ustalajca pojedynczy element tablicy Rand
        'Dostp z zewntrz poprzez property Rand()
        '*****************************************************************************
        Private Sub PutRand(ByVal Index As Integer, ByVal B As Byte)
            Data(Index) = B
        End Sub
        '*****************************************************************************
        'Metoda prywatna zwracajca pojedynczy element tablicy RandPC
        'Dostp z zewntrz poprzez property RandPC()
        '*****************************************************************************
        Function GetRandPC(ByVal Index As Integer) As Byte
            GetRandPC = Data(Index + 16)
        End Function

        '*****************************************************************************
        'Metoda prywatna ustalajca pojedynczy element tablicy RandPC
        'Dostp z zewntrz poprzez property RandPC()
        '*****************************************************************************
        Private Sub PutRandPC(ByVal Index As Integer, ByVal B As Byte)
            Data(Index + 16) = B
        End Sub

        '*****************************************************************************
        'Metoda prywatna zwracajca pojedynczy element tablicy RandT
        'Dostp z zewntrz poprzez property RandT()
        '*****************************************************************************
        Private Function GetRandT(ByVal Index As Integer) As Byte
            GetRandT = Data(Index + 32)
        End Function

        '*****************************************************************************
        'Metoda prywatna ustalajca pojedynczy element tablicy RandT
        'Dostp z zewntrz poprzez property RandT()
        '*****************************************************************************
        Private Sub PutRandT(ByVal Index As Integer, ByVal B As Byte)
            Data(Index + 32) = B
        End Sub

        '*****************************************************************************
        'Metoda prywatna zwracajca pojedynczy element tablicy Key
        'Dostp z zewntrz poprzez property Key()
        '*****************************************************************************
        Private Function GetKey(ByVal Index As Integer) As Byte
            GetKey = Data(Index + 48)
        End Function

        '*****************************************************************************
        'Metoda prywatna ustalajca pojedynczy element tablicy Key
        'Dostp z zewntrz poprzez property Key()
        '*****************************************************************************
        Private Sub PutKey(ByVal Index As Integer, ByVal B As Byte)
            Data(Index + 48) = B
        End Sub

        '*****************************************************************************
        'Metoda prywatna zwracajca uchwyt na Token
        'Dostp z zewntrz poprzez property hToken
        '*****************************************************************************
        Private Function GethToken() As Long
            Dim n As Long            
            GethToken = Data(64)
            n = Data(65) * &H100
            GethToken = GethToken + n
            n = Data(66) * &H10000
            GethToken = GethToken + n
            n = Data(67)
            n = n * &H1000000
            n = n And 4294967295
            GethToken = GethToken Or n
        End Function

        '*****************************************************************************
        'Metoda prywatna ustalajca uchwyt na Token
        'Dostp z zewntrz poprzez property hToken
        '*****************************************************************************
        Private Sub PuthToken(ByVal C As Long)
            Dim tmp As Byte

            tmp = C And &HFF
            Data(64) = tmp
            tmp = (C \ &H100) And &HFF
            Data(65) = tmp
            tmp = (C \ &H10000) And &HFF
            Data(66) = tmp
            tmp = (C \ &H1000000) And &HFF
            Data(67) = tmp
        End Sub

        '*****************************************************************************
        'Metoda prywatna zwracajca OutKey
        'Dostp z zewntrz poprzez property OutKey
        '*****************************************************************************
        Private Function GetOutKey() As Long
            Dim n As Long
            GetOutKey = Data(68)
            n = (Data(69) * &H100)
            GetOutKey = GetOutKey + n
            n = (Data(70) * &H10000)
            GetOutKey = GetOutKey + n
            n = Data(71)
            n = n * &H1000000
            n = n And 4294967295
            GetOutKey = GetOutKey Or n
        End Function

        '*****************************************************************************
        'Metoda prywatna ustalajca OutKey
        'Dostp z zewntrz poprzez property OutKey
        '*****************************************************************************
        Private Sub PutOutKey(ByVal C As Long)
            Data(68) = C And &HFF
            Data(69) = (C \ &H100) And &HFF
            Data(70) = (C \ &H10000) And &HFF
            Data(71) = (C \ &H1000000) And &HFF
        End Sub

        '*****************************************************************************
        'Metoda prywatna zwracajca InKey
        'Dostp z zewntrz poprzez property InKey
        '*****************************************************************************
        Private Function GetInKey() As Long
            Dim n As Long
            GetInKey = Data(72)
            n = (Data(73) * &H100)
            GetInKey = GetInKey + n
            n = (Data(74) * &H10000)
            GetInKey = GetInKey + n
            n = Data(75)
            n = n * &H1000000
            n = n And 4294967295
            GetInKey = GetInKey Or n
        End Function

        '*****************************************************************************
        'Metoda prywatna ustalajca InKey
        'Dostp z zewntrz poprzez property InKey
        '*****************************************************************************
        Private Sub PutInKey(ByVal C As Long)
            Data(72) = C And &HFF
            Data(73) = (C \ &H100) And &HFF
            Data(74) = (C \ &H1000) And &HFF
            Data(75) = (C \ &H100000) And &HFF
        End Sub

        '*****************************************************************************
        'Metoda prywatna zwracajca pojedynczy element tablicy TokenInfo
        'Dostp z zewntrz poprzez property TokenInfo()
        '*****************************************************************************
        Private Function GetTokenInfo(ByVal Index As Integer) As Long
            Dim shift As Integer
            Dim n As Long
            shift = 76 + Index * 4
            GetTokenInfo = Data(shift)
            n = (Data(shift + 1) * &H100)
            GetTokenInfo = GetTokenInfo + n
            n = (Data(shift + 2) * &H10000)
            GetTokenInfo = GetTokenInfo + n
            n = Data(shift + 3)
            n = n * &H1000000
            n = n And 4294967295
            GetTokenInfo = GetTokenInfo Or n
        End Function

        '*****************************************************************************
        'Metoda prywatna ustalajca pojedynczy element tablicy TokenInfo
        'Dostp z zewntrz poprzez property TokenInfo()
        '*****************************************************************************
        Private Sub PutTokenInfo(ByVal Index As Integer, ByVal C As Integer)
            Dim shift As Integer
            shift = 76 + Index * 4
            Data(shift) = C And &HFF
            Data(shift + 1) = (C \ &H100) And &HFF
            Data(shift + 2) = (C \ &H10000) And &HFF
            Data(shift + 3) = (C \ &H1000000) And &HFF
        End Sub

        '*****************************************************************************
        'Metoda prywatna zwracajca rozmiar TokenInfo
        'Dostp z zewntrz poprzez property TokenInfoSize
        '*****************************************************************************
        Private Function GetTokenInfoSize() As Long
            Dim n As Long
            GetTokenInfoSize = Data(1100)
            n = (Data(1101) * &H100)
            GetTokenInfoSize = GetTokenInfoSize + n
            n = (Data(1102) * &H10000)
            GetTokenInfoSize = GetTokenInfoSize + n
            n = Data(1103)
            n = n * &H1000000
            n = n And 4294967295
            GetTokenInfoSize = GetTokenInfoSize Or n
        End Function

        '*****************************************************************************
        'Metoda prywatna ustalajca rozmiar TokenInfo
        'Dostp z zewntrz poprzez property TokenInfoSize
        '*****************************************************************************
        Private Sub PutTokenInfoSize(ByVal C As Integer)
            Data(1100) = C And &HFF
            Data(1101) = (C \ &H100) And &HFF
            Data(1102) = (C \ &H10000) And &HFF
            Data(1103) = (C \ &H1000000) And &HFF
        End Sub


        '*****************************************************************************
        'Klasa polaczenia CTVTTAPI_INT_CON
        '*****************************************************************************

        '*****************************************************************************
        'Metoda zwracajca rozmiar wew. struktury danych
        '(w celu zachowania kompatybilnoci wstecz)
        '*****************************************************************************
        Public Function GetSize() As Integer
            GetSize = UBound(Data)
        End Function

        '*****************************************************************************
        'Metoda czyszczca tablic Rand
        '*****************************************************************************
        Public Sub ZeroRand()
            ZeroMemory(Data, 16, 0)
        End Sub

        ''*****************************************************************************
        'Metoda czyszczca tablic RandPC
        '*****************************************************************************
        Public Sub ZeroRandPC()
            ZeroMemory(Data, 16, 16)
        End Sub

        '*****************************************************************************
        'Metoda czyszczca tablic RandT
        '*****************************************************************************
        Public Sub ZeroRandT()
            ZeroMemory(Data, 16, 32)
        End Sub

        '*****************************************************************************
        'Metoda czyszczca tablic Key
        '*****************************************************************************
        Public Sub ZeroKey()
            ZeroMemory(Data, 16, 48)
        End Sub

        '*****************************************************************************
        'Metoda kopiujca tablic RandPC z obiektu klasy CTVTTAPI_RandPC
        '*****************************************************************************
        Public Sub CopyRandPC(ByVal PC As CTVTTAPI_RandPC)
            CopyTable(Data, PC.Data, 16, 0, 16)
        End Sub

        '*****************************************************************************
        'Metoda kopiujca tablic RandT z obiektu klasy CTVTTAPI_RandT
        '*****************************************************************************
        Public Sub CopyRandT(ByVal T As CTVTTAPI_RandT)
            CopyTable(Data, T.Data, 32, 0, 16)
        End Sub

        '*****************************************************************************
        'Metoda kopiujca tablic Key z obiektu klasy CTVTTAPI_Key
        '*****************************************************************************
        Public Sub CopyKey(ByVal K As CTVTTAPI_Key)
            CopyTable(Data, K.Data, 48, 0, 16)
        End Sub

        Property Rand(ByVal Index As Integer) As Byte
            Get
                Rand = GetRand(Index)
            End Get
            Set(ByVal Value As Byte)
                PutRand(Index, Value)
            End Set
        End Property

        Public Property RandPC(ByVal Index As Integer) As Byte
            Get
                RandPC = GetRandPC(Index)
            End Get
            Set(ByVal Value As Byte)
                PutRandPC(Index, Value)
            End Set
        End Property

        Public Property RandT(ByVal Index As Integer) As Byte
            Get
                RandT = GetRandT(Index)
            End Get
            Set(ByVal Value As Byte)
                PutRandT(Index, Value)
            End Set
        End Property

        Public Property Key(ByVal Index As Integer) As Byte
            Get
                Key = GetKey(Index)
            End Get
            Set(ByVal Value As Byte)
                PutKey(Index, Value)
            End Set
        End Property

        Public Property hToken() As Long
            Get
                hToken = GethToken()
            End Get
            Set(ByVal Value As Long)
                PuthToken(Value)
            End Set
        End Property

        Public Property OutKey() As Long
            Get
                OutKey = GetOutKey()
            End Get
            Set(ByVal Value As Long)
                PutOutKey(Value)
            End Set
        End Property

        Public Property InKey() As Long
            Get
                InKey = GetInKey()
            End Get
            Set(ByVal Value As Long)
                PutInKey(Value)
            End Set
        End Property

        Public Property TokenInfo(ByVal Index As Integer) As Long
            Get
                TokenInfo = GetTokenInfo(Index)
            End Get
            Set(ByVal Value As Long)
                PutTokenInfo(Index, Value)
            End Set
        End Property
        Public Property TokenInfoSize() As Long
            Get
                TokenInfoSize = GetTokenInfoSize()
            End Get
            Set(ByVal Value As Long)
                PutTokenInfoSize(Value)
            End Set
        End Property

    End Class


    Public TVTTAPI_Int_LastUpdate As Integer = 0

    '*****************************************************************************
    'Funkcja wewntrzna - szyfruje strukture opisujc poczenie
    'We 
    '    Klucz szyfrowania
    '    Obiekt poczenia
    'Wy 
    '*****************************************************************************
    Public Sub TVTTAPI_Int_CodeCon(ByRef Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON)
        Dim n, i As Integer

        TVTT_Rand(Con.Data, 0)
        n = 16
        While n < (((TVTTAPI_INT_CON_SIZE + 15) \ 16) * 16)

            i = 0
            While (i < 16)
                Con.Data(n + i) = (Con.Data(n + i) Xor Con.Data(n + i - 16)) And &HFF
                i = i + 1
            End While
            rijndaelEncrypt(Pass, 0, Con.Data, n)
            n = n + 16
        End While
    End Sub

    '*****************************************************************************
    'Funkcja wewntrzna - rozszyfruje strukture opisujc poczenie
    'We
    '               Klucz(szyfrowania)
    '                Obiekt(poczenia)
    'Wy
    '*****************************************************************************
    Public Sub TVTTAPI_Int_DecodeCon(ByRef Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON)
        Dim n, i As Integer

        n = (((TVTTAPI_INT_CON_SIZE + 15) \ 16) * 16) - 16
        While (n > 15)

            rijndaelDecrypt(Pass, 0, Con.Data, n)
            i = 0
            While (i < 16)
                Con.Data(n + i) = (Con.Data(n + i) Xor Con.Data(n + i - 16)) And &HFF
                i = i + 1
            End While
            n = n - 16
        End While

    End Sub

    '*****************************************************************************
    'Funkcja wewntrzna - na podstawie zwrconego kodu bdu ustawia "LastError"
    'We 
    '        kod(bdu)
    'Wy 
    '        ustawiony("LastError")
    '*****************************************************************************

    Public Sub TVTTAPI_Int_SetLastError(ByVal Res As Integer)

        Select Case (Res And &HFF00)
            Case TVTTS_TOO_MANY_OPEN_TOKENS
                SetLastError(ERROR_TOO_MANY_OPEN_FILES)

            Case TVTTS_USB_DOES_NOT_EXIST
                SetLastError(ERROR_UNKNOWN_PORT)

            Case TVTTS_TOKEN_NOT_FOUND

                SetLastError(ERROR_NOT_FOUND)

            Case TVTTS_TIME_OUT

                SetLastError(ERROR_TIMEOUT)

            Case TVTTS_EXPIRED
                SetLastError(ERROR_ACCOUNT_EXPIRED)

            Case TVTTS_ALREADY_OPENED

                SetLastError(ERROR_ALREADY_INITIALIZED)

            Case TVTTS_UNKNOWN_ERROR, TVTTS_NULL_PTR, TVTTS_BAD_PARAM, TVTTS_INVALID_HANDLE
                SetLastError(ERROR_UNEXP_NET_ERR)
        End Select

        Select Case (Res And &HFF)
            Case TVTTS_NO_OPEN
                SetLastError(ERROR_ACCOUNT_EXPIRED)

            Case TVTTS_EXPIRED
                SetLastError(ERROR_TIMEOUT)

            Case TVTTS_DAMAGED
                SetLastError(ERROR_GEN_FAILURE)

            Case TVTTS_NOT_SUPPORTED
                SetLastError(ERROR_NOT_SUPPORTED)

            Case TVTTS_OUT_OF_RANGE
                SetLastError(ERROR_INVALID_BLOCK)

            Case TVTTS_PROTECTION_NOT_SUPPORTED
                SetLastError(ERROR_SET_NOT_FOUND)

            Case TVTTS_PASS_NOT_PERMITTED
                SetLastError(ERROR_INVALID_PASSWORD)

            Case TVTTS_NOT_PERMITTED
                SetLastError(ERROR_ACCESS_DENIED)

            Case TVTTS_ACCESS_EXPIRED
                SetLastError(ERROR_COUNTER_TIMEOUT)
        End Select

        If (Res <> 0) Then
            SetLastError(ERROR_UNEXP_NET_ERR)
        Else
            SetLastError(ERROR_SUCCESS)
        End If
    End Sub

    '*****************************************************************************
    'Funkcja wewntrzna - testuje poprawnoc komunikacji
    'We
    '            kod(bdu)
    'Wy 
    '	0 - bez bedw / <> 0 - wystapi bd
    '            ustawiony("LastError")
    '*****************************************************************************

    Function TVTTAPI_Int_CheckError(ByRef Con As CTVTTAPI_INT_CON, ByVal Res As Integer, ByVal InKey As Integer, ByRef InDataA() As Byte, ByRef InDataB() As Byte) As Byte
        Dim tmp As Long

        If Res <> 0 Then
            TVTTAPI_Int_SetLastError(Res)
            Return 1
        End If

        If InKey = 0 Then
            If TVTT_CheckAuth(InDataA, InDataB) <> 0 Then
                SetLastError(ERROR_CRC)
            Else
                If InDataB(TVTTD_STATUS) <> 0 Then
                    TVTTAPI_Int_SetLastError(InDataB(TVTTD_STATUS))
                Else
                    SetLastError(ERROR_UNEXP_NET_ERR)
                End If
                Return 1
            End If
        Else
            tmp = Con.InKey
            tmp = tmp And 4278190080                    '&HFF000000
            If tmp > 0 Then
                Con.InKey = InKey
            ElseIf InKey <> Con.InKey Then
                SetLastError(ERROR_UNEXP_NET_ERR)
                Return 1
            End If
            Con.InKey = ((Con.InKey + 1) And 16777215)  '&HFFFFFF
        End If

        If TVTT_CheckAuth(InDataA, InDataB) <> 0 Then
            SetLastError(ERROR_CRC)
            Return 1
        End If

        If InDataB(TVTTD_STATUS) <> 0 Then
            TVTTAPI_Int_SetLastError(InDataB(TVTTD_STATUS))
            Return 1
        End If

        Return 0
    End Function

    '*****************************************************************************
    'Funkcja inicjalizuje bibliotek
    'We
    'Wy
    '****************************************************************************
    Public Sub TVTTAPI_Initialize()
        Dim InitTab(TVTT_RAND_INIT_TBL_SIZE - 1) As Byte
        Dim hKeyr As Integer
        Dim Res, n, i As Integer
        Dim l As Long

        n = 0
        While n < TVTT_RAND_INIT_TBL_SIZE
            InitTab(n) = (GetTickCount() And &HFF)
            n = n + 1
        End While

        l = RegCreateKeyEx(HKEY_CURRENT_USER, TVTTAPI_Int_Name, 0, 0, REG_OPTION_NON_VOLATILE, KEY_QUERY_VALUE Or KEY_SET_VALUE, 0, hKeyr, Res)
        If (l = ERROR_SUCCESS) And (Res = REG_OPENED_EXISTING_KEY) Then
            n = TVTT_RAND_INIT_TBL_SIZE
            i = REG_BINARY
            RegQueryValueEx(hKeyr, "", 0, i, InitTab(0), n)
        End If

        TVTT_RandInit(InitTab)
        TVTT_RandGetInit(InitTab)

        RegSetValueEx(hKeyr, 0, 0, REG_BINARY, InitTab, TVTT_RAND_INIT_TBL_SIZE)

        If l = ERROR_SUCCESS Then RegCloseKey(hKeyr)

        ZeroMemory(InitTab, TVTT_RAND_INIT_TBL_SIZE, 0)
        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja dodaje zdarzenia do generatora liczb pseudolosowych
    'We
    '    Struktura wiadomoci systemowej
    'Wy
    '*****************************************************************************
    Public Sub TVTTAPI_Randomize(ByVal Msg As Message)
        Dim InitTab(TVTT_RAND_INIT_TBL_SIZE - 1) As Byte
        Dim n As Byte
        Dim Timer As Long
        Dim l As Long
        Dim hKeyr As Long
        Dim Res As Long

        n = &HFF

        Select Case (Msg.Result.ToInt32)
            Case WM_KEYUP
                n = 0

            Case WM_KEYDOWN
                n = 1

            Case WM_MOUSEMOVE
                n = 2

            Case WM_LBUTTONDOWN
                n = 3

            Case WM_LBUTTONUP
                n = 4

            Case WM_MBUTTONDOWN
                n = 5

            Case WM_MBUTTONUP
                n = 6

            Case WM_RBUTTONDOWN
                n = 7

            Case WM_RBUTTONUP
                n = 8
        End Select

        If ((n * 3) < 31) Then
            TVTT_Randomize((n * 3) + 0, GetTickCount())
            TVTT_Randomize((n * 3) + 1, ((Msg.WParam.ToInt32)))
            TVTT_Randomize((n * 3) + 2, ((Msg.LParam.ToInt32)))
        End If

        Timer = GetTickCount()
        If (TVTTAPI_Int_LastUpdate And &H80000000) > 0 Then
            If (Timer And &H80000000) > 0 Then
                If (TVTTAPI_Int_LastUpdate + 10000) < TVTTAPI_Int_LastUpdate Then Exit Sub
                If Time < (TVTTAPI_Int_LastUpdate + 10000) Then Exit Sub
            End If
        Else
            If Time < (TVTTAPI_Int_LastUpdate + 10000) Then Exit Sub
        End If

        TVTTAPI_Int_LastUpdate = Timer

        l = RegCreateKeyEx(HKEY_CURRENT_USER, TVTTAPI_Int_Name, 0, 0, REG_OPTION_NON_VOLATILE, KEY_QUERY_VALUE Or KEY_SET_VALUE, 0, hKeyr, Res)
        If (l = ERROR_SUCCESS) And (Res = REG_OPENED_EXISTING_KEY) Then
            TVTT_RandGetInit(InitTab)
            RegSetValueEx(hKeyr, 0, 0, REG_BINARY, InitTab, TVTT_RAND_INIT_TBL_SIZE)
        End If
        If l = ERROR_SUCCESS Then RegCloseKey(hKeyr)

        ZeroMemory(InitTab, TVTT_RAND_INIT_TBL_SIZE, 0)
    End Sub

    '*****************************************************************************
    'Funkcja wypenia podany blok wartoci pseudolosow
    'We
    '    Adres na tablice do wypenienia
    'Wy
    '*****************************************************************************
    Public Sub TVTTAPI_Rand(ByVal Random() As Byte)
        TVTT_Rand(Random, 0)
        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja znajduje Token i otwiera poczenie z Tokenem
    'We 
    '   Adres na 16-bajtowy klucz do poczenia
    '    ID odbiorcy tokenu
    '    Maska odbiorcy tokenu
    '   Ilo Tokenw do pominicia
    'Wy 
    '   obiekt poczenia z tokenem lub nil jeli bd
    '        ustawiony("LastError")
    '*****************************************************************************
    Function TVTTAPI_Open(ByRef Pass() As Byte, ByVal OwnerID As Integer, ByVal OwnerMsk As Byte, ByVal Skip As Byte) As CTVTTAPI_INT_CON
        Dim Res As Long
        Dim TITS As Integer
        Dim Con As CTVTTAPI_INT_CON
        Dim hToken As Integer
        Dim TokenInfo(256) As Integer
        Dim TokenInfoSize As Integer
        Dim tmp As Integer


        If Pass Is Nothing Then
            SetLastError(ERROR_INVALID_DATA)
            Return Nothing
        End If

        Con = New CTVTTAPI_INT_CON

        TokenInfoSize = TVTTTI_TABLE_SIZE
        Res = TVTT_FindToken(hToken, 50, OwnerID, OwnerMsk, Skip, TokenInfoSize, TokenInfo(0))

        If Res <> 0 Then
            TVTTAPI_Int_SetLastError(Res)
            ZeroMemory(Con.Data, ((TVTTAPI_INT_CON_SIZE + 15) \ 16) * 16, 0)
            Con.Free()
            Return Nothing
        End If

        Con.hToken = hToken
        Con.TokenInfoSize = TokenInfoSize
        For tmp = 0 To TVTTTI_TABLE_SIZE - 1
            Con.TokenInfo(tmp) = TokenInfo(tmp)
        Next

        TVTTAPI_Int_CodeCon(Pass, Con)

        SetLastError(ERROR_SUCCESS)
        Return Con
    End Function

    '*****************************************************************************
    'Funkcja zamyka poczenie z Tokenem i zwalnia zasoby
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '            Obiekt(poczenia)
    'Wy 
    '           ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_Close(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON)
        Dim Res As Long

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        Res = TVTT_FreeToken(Con.hToken)
        If Res <> 0 Then

            TVTTAPI_Int_CodeCon(Pass, Con)
            TVTTAPI_Int_SetLastError(Res)
            Exit Sub
        End If

        ZeroMemory(Con.Data, ((Con.GetSize + 15) \ 16) * 16, 0)
        Con.Free()
        Con = Nothing
        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja zwraca warto opisujc konkretn waciwo Tokenu
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer waciwoci Tokenu
    'Wy
    '        waciwo(Tokenu)
    '        ustawiony("LastError")
    '*****************************************************************************
    Function TVTTAPI_GetFeature(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal FNr As Integer) As Long
        Dim Res As Long

        Res = 0
        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Return Res
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        If FNr < Con.TokenInfoSize Then Res = Con.TokenInfo(FNr)

        TVTTAPI_Int_CodeCon(Pass, Con)

        SetLastError(ERROR_SUCCESS)
        Return Res
    End Function

    '*****************************************************************************
    'Funkcja rozpoczyna sesj z tokenem
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '       Obiekt(poczenia)
    '    Numer hasa proponowanego przez PC
    'Wy
    '    Numer hasa zaproponowanego przez Token
    '       ustawiony("LastError")
    '*****************************************************************************
    Function TVTTAPI_StartSession(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal PCPassNr As Byte) As Byte
        Dim Res As Integer
        Dim InKey As Integer
        Dim TPassNr As Byte
        Dim OutData(15) As Byte
        Dim InData(15) As Byte
        Dim RandPC As CTVTTAPI_RandPC
        Dim RandT As CTVTTAPI_RandT


        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Return 0
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        Res = TVTT_StartSession(Con.hToken, 1)
        If Res <> 0 Then
            TVTTAPI_Int_CodeCon(Pass, Con)
            TVTTAPI_Int_SetLastError(Res)
            Return 0
        End If

        ZeroMemory(Con.Data, 16, 16)
        ZeroMemory(OutData, 16, 0)
        ZeroMemory(Con.Data, 16, 24)
        ZeroMemory(InData, 16, 0)

        Con.OutKey = 0
        Con.InKey = 4294967295        

        RandPC = New CTVTTAPI_RandPC
        TVTT_Rand(RandPC.Data, 0)

        OutData(TVTTD_CMD) = TVTTC_OPEN
        OutData(TVTTD_PARAM1) = PCPassNr

        RandT = New CTVTTAPI_RandT
        TVTT_CalcAuth(RandPC.Data, OutData)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, RandPC.Data(0), OutData(0), InKey, RandT.Data(0), InData(0))
        Con.CopyRandPC(RandPC)
        Con.CopyRandT(RandT)
        RandPC.Free()
        RandT.Free()

        If Res <> 0 Then
            InKey = 0
            Con.ZeroRandPC()
            ZeroMemory(OutData, 16, 0)
            Con.ZeroRandT()
            ZeroMemory(InData, 16, 0)
            TVTT_EndSession(Con.hToken)
            TVTTAPI_Int_CodeCon(Pass, Con)
            TVTTAPI_Int_SetLastError(Res)
            Return 0
        End If

        If InKey <> 0 Then
            InKey = 0
            Con.ZeroRandPC()
            ZeroMemory(OutData, 16, 0)
            Con.ZeroRandT()
            ZeroMemory(InData, 16, 0)
            TVTT_EndSession(Con.hToken)
            TVTTAPI_Int_CodeCon(Pass, Con)
            SetLastError(ERROR_UNEXP_NET_ERR)
            Return 0
        End If

        RandT = New CTVTTAPI_RandT(Con)
        If TVTT_CheckAuth(RandT.Data, InData) <> 0 Then
            RandT.Free()
            InKey = 0
            Con.ZeroRandPC()
            ZeroMemory(OutData, 16, 0)
            Con.ZeroRandT()
            ZeroMemory(InData, 16, 0)
            TVTT_EndSession(Con.hToken)
            TVTTAPI_Int_CodeCon(Pass, Con)
            SetLastError(ERROR_CRC)
            Return 0
        End If
        RandT.Free()

        If InData(TVTTD_STATUS) <> 0 Then
            TVTT_EndSession(Con.hToken)
            TVTTAPI_Int_CodeCon(Pass, Con)
            TVTTAPI_Int_SetLastError(InData(TVTTD_STATUS))
            InKey = 0
            Con.ZeroRandPC()
            ZeroMemory(OutData, 16, 0)
            Con.ZeroRandT()
            ZeroMemory(InData, 16, 0)
            Return 0
        End If

        TPassNr = InData(TVTTD_PARAM1)

        ZeroMemory(OutData, 16, 0)
        ZeroMemory(InData, 16, 0)
        InKey = 0

        TVTT_Rand(OutData, 0)

        Con.OutKey = OutData(0)
        Con.OutKey = Con.OutKey * &H100
        Con.OutKey = Con.OutKey Or OutData(1)
        Con.OutKey = Con.OutKey * &H100
        Con.OutKey = Con.OutKey Or OutData(2)
        Con.OutKey = Con.OutKey And &H7FFFFFF
        ZeroMemory(OutData, 16, 0)

        TVTTAPI_Int_CodeCon(Pass, Con)

        SetLastError(ERROR_SUCCESS)
        Return TPassNr
    End Function


    '****************************************************************************
    'Funkcja koczy sesj z tokenem
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_EndSession(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON)
        Dim Res, Res2, InKey As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_CLOSE

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        Key.Free()
        If Res <> 0 Then TVTTAPI_Int_SetLastError(Res)

        Res2 = TVTT_EndSession(Con.hToken)
        If (Res = 0) And (Res2 <> 0) Then TVTTAPI_Int_SetLastError(Res2)

        Con.OutKey = 0

        TVTTAPI_Int_CodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)
        InKey = 0
        Key.Free()

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja wylicza haso sesji na podstawie zaproponowanych hase
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '       Obiekt(poczenia)
    '    Haso proponowane przez PC
    '    Haso proponowane przez T
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_CalcPass(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal PassPC() As Byte, ByVal PassT() As Byte)
        Dim Key As CTVTTAPI_Key
        Dim RandPC As CTVTTAPI_RandPC
        Dim RandT As CTVTTAPI_RandT

        If (Pass Is Nothing) Or (Con Is Nothing) Or (PassPC Is Nothing) Or (PassT Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        Key = New CTVTTAPI_Key
        RandPC = New CTVTTAPI_RandPC(Con)
        RandT = New CTVTTAPI_RandT(Con)
        TVTT_CalcSessionKey(Key.Data, PassPC, RandPC.Data, PassT, RandT.Data)
        Con.CopyKey(Key)
        Key.Free()
        RandPC.Free()
        RandT.Free()

        Con.ZeroRandPC()
        Con.ZeroRandT()

        TVTTAPI_Int_CodeCon(Pass, Con)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja odczytuje sektor z pamici nieulotnej
    'We 
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer sektora do odczytania
    '    Tablica bufora na sektor
    'Wy 
    '    wypeniony bufor na sektor (byref Buff)
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_MemRead(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal SNr As Byte, ByRef Buff() As Byte)
        Dim Res, InKey As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Or (Buff Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        ZeroMemory(Buff, 16, 0)

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_NVMEM_READ
        OutDataB(TVTTD_PARAM1) = SNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        CopyTable(Buff, InDataA, 0, 0, 16)

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja odczytuje sektor z pamici ulotnej
    'We 
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer sektora do odczytania
    '    Tablica bufora na sektor
    'Wy 
    '    wypeniony bufor na sektor (byref Buff)
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_RamRead(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal SNr As Byte, ByRef Buff() As Byte)
        Dim Res, InKey As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Or (Buff Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        ZeroMemory(Buff, 16, 0)

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_VMEM_READ
        OutDataB(TVTTD_PARAM1) = SNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        CopyTable(Buff, InDataA, 0, 0, 16)

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja zapisuje sektor do pamici ulotnej
    'We 
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer sektora do zapisania
    '    Tablica bufora z danymi do zapisania
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_RamWrite(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal SNr As Byte, ByVal Buff() As Byte)
        Dim Res, InKey As Integer
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Or (Buff Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        CopyTable(OutDataA, Buff, 0, 0, 16)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_VMEM_WRITE
        OutDataB(TVTTD_PARAM1) = SNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja zapisuje sektor do pamici nieulotnej
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer sektora do zapisania
    '    Tablica bufora z danymi do zapisania
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_MemWrite(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal SNr As Byte, ByVal Buff() As Byte)
        Dim Res, InKey As Integer
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Or (Buff Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        CopyTable(OutDataA, Buff, 0, 0, 16)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_NVMEM_WRITE
        OutDataB(TVTTD_PARAM1) = SNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja zapisuje sektor do pamici nieulotnej i zabezpiecza sektor przed zapisem
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer sektora do zapisania
    '    Tablica bufora z danymi do zapisania
    'Wy 
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_MemWriteProtect(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal SNr As Byte, ByVal Buff() As Byte)
        Dim Res, InKey As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Or (Buff Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        CopyTable(OutDataA, Buff, 0, 0, 16)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_NVMEM_WRITE_PROTECT
        OutDataB(TVTTD_PARAM1) = SNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja zabezpiecza sektor w pamieci nieulotnej przed zapisem
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer sektora do zabezpieczenia
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_MemProtect(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal SNr As Byte)

        Dim Res, InKey As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_NVMEM_PROTECT
        OutDataB(TVTTD_PARAM1) = SNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja szyfruje blok danych o rozmiarze szesnastu bajtw przy uyciu Tokenu
    'We  
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer hasa do zaszyfrowania
    '    Tablica bufora z danymi do zaszyfrowania
    'Wy
    '    zaszyfrowane dane w buforze
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_Encrypt(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal PNr As Byte, ByRef Buff() As Byte)
        Dim Res, InKey As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Or (Buff Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        CopyTable(OutDataA, Buff, 0, 0, 16)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_ENCRYPT
        OutDataB(TVTTD_PARAM1) = PNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        CopyTable(Buff, InDataA, 0, 0, 16)

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja deszyfruje blok szesnastu bajtw danych przy uyciu Tokenu
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer hasa do zaszyfrowania
    '    Tablica bufora z danymi do zaszyfrowania
    'Wy
    '    zaszyfrowane dane w buforze
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_Decrypt(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal PNr As Byte, ByRef Buff() As Byte)
        Dim Res, InKey As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Or (Buff Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        CopyTable(OutDataA, Buff, 0, 0, 16)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_DECRYPT
        OutDataB(TVTTD_PARAM1) = PNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        CopyTable(Buff, InDataA, 0, 0, 16)

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja odczytuje wartoc z licznika uniwersalnego
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer licznika do odczytania
    'Wy
    '    Warto odczytana z licznika
    '        ustawiony("LastError")
    '*****************************************************************************
    Function TVTTAPI_CounterRead(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal CNr As Byte) As Integer
        Dim Res As Long
        Dim InKey As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Return 0
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_CNT_READ
        OutDataB(TVTTD_PARAM1) = CNr


        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)        
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Return 0
        End If

        Res = InDataA(1)
        Res = Res * &H100
        Res = Res Or InDataA(0)        

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
        Return Res
    End Function

    '*****************************************************************************
    'Funkcja zwiksza licznik i odczytuje jego warto
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer licznika do odczytania
    'Wy
    '    Warto odczytana z licznika
    '        ustawiony("LastError")
    '*****************************************************************************
    Function TVTTAPI_CounterIncRead(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal CNr As Byte) As Integer
        Dim Res As Long
        Dim InKey As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Return 0
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_CNT_INC_READ
        OutDataB(TVTTD_PARAM1) = CNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Return 0
        End If

        Res = InDataA(1)
        Res = Res * &H100
        Res = Res Or InDataA(0)

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
        Return Res
    End Function

    '*****************************************************************************
    'Funkcja zmniejsza licznik i odczytuje jego warto
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer licznika do odczytania
    'Wy
    '    Warto odczytana z licznika
    '        ustawiony("LastError")
    '*****************************************************************************
    Function TVTTAPI_CounterDecRead(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal CNr As Byte) As Integer
        Dim Res As Long
        Dim InKey As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key


        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Return 0
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_CNT_DEC_READ
        OutDataB(TVTTD_PARAM1) = CNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))

        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Return 0
        End If

        Res = InDataA(1)
        Res = Res * &H100
        Res = Res Or InDataA(0)

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
        Return Res
    End Function

    '*****************************************************************************
    'Funkcja zwiksza licznik, odczytuje jego zawartoc i odsya ja zaszyfrowan
    '        podanym(hasem)
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer licznika do odczytania
    '    Numer hasa ktrym ma nastpi szyfrowanie
    '    Tablica bufora na dane
    'Wy
    '    wypeniony bufor na dane
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_CounterIncEncryptRead(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal CNr As Byte, ByVal PNr As Byte, ByRef Buff() As Byte)
        Dim InKey, Res As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Or (Buff Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        ZeroMemory(Buff, 16, 0)

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_CNT_INC_ENCRYPT_READ
        OutDataB(TVTTD_PARAM1) = CNr
        OutDataB(TVTTD_PARAM2) = PNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))
        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        CopyTable(Buff, InDataA, 0, 0, 16)

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja zapisuje warto do licznika uniwersalnego
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer licznika do zapisania
    '    Wartoc do zapisania
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_CounterWrite(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal CNr As Byte, ByVal Value As Integer)
        Dim InKey, Res As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        OutDataA(0) = Value And &HFF
        Value = Value \ &H100
        OutDataA(1) = Value And &HFF
        Value = 0
        ' ominiecie optymalizacji kodu przez kompilator
        OutDataA(2) = Value

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_CNT_WRITE
        OutDataB(TVTTD_PARAM1) = CNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))

        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja zapisuje dwa bajty konfiguracji licznika
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer licznika do zapisania konfiguracji
    '    Wartoc pierwszego bajtu konfiguracji
    '    Wartoc drugiego bajtu konfiguracji
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_CounterConfigWrite(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal CNr As Byte, ByVal Config0 As Byte, ByVal Config1 As Byte)
        Dim InKey, Res As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        OutDataA(0) = Config0
        OutDataA(1) = Config1

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_CNT_WRITE_CONFIG
        OutDataB(TVTTD_PARAM1) = CNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))

        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja ustawia bity w dwch bajtach konfiguracji licznika
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer licznika do zapisania konfiguracji
    '    Maska bitowa pierwszego bajtu konfiguracji
    '    Maska bitowa pierwszego bajtu konfiguracji
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_CounterConfigSet(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal CNr As Byte, ByVal Config0 As Byte, ByVal Config1 As Byte)
        Dim InKey, Res As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        OutDataA(0) = Config0
        OutDataA(1) = Config1

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_CNT_SET_CONFIG
        OutDataB(TVTTD_PARAM1) = CNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))

        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja kasuje bity w dwch bajtach konfiguracji licznika
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer licznika do zapisania konfiguracji
    '    Maska bitowa pierwszego bajtu konfiguracji
    '    Maska bitowa pierwszego bajtu konfiguracji
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_CounterConfigClear(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal CNr As Byte, ByVal Config0 As Byte, ByVal Config1 As Byte)
        Dim InKey, Res As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        OutDataA(0) = Config0
        OutDataA(1) = Config1

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_CNT_CLR_CONFIG
        OutDataB(TVTTD_PARAM1) = CNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))

        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja zapisuje haso do tablicy hase
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer pozycji w tablicy hase
    '    Tablica bufora z hasem do zapisania
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_PassWrite(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal PNr As Byte, ByVal Buff() As Byte)
        Dim InKey, Res As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Or (Buff Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        CopyTable(OutDataA, Buff, 0, 0, 16)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_PASS_WRITE
        OutDataB(TVTTD_PARAM1) = PNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))

        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja zapisuje dwa bajty konfiguracji hasa
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer hasa do zapisania konfiguracji
    '    Wartoc pierwszego bajtu konfiguracji
    '    Wartoc drugiego bajtu konfiguracji
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_PassConfigWrite(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal PNr As Byte, ByVal Config0 As Byte, ByVal Config1 As Byte)
        Dim InKey, Res As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        OutDataA(0) = Config0
        OutDataA(1) = Config1

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_PASS_WRITE_CONFIG
        OutDataB(TVTTD_PARAM1) = PNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))

        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja ustawia bity w dwuch bajtach konfiguracji hasa
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer hasa do zapisania konfiguracji
    '    Maska bitowa pierwszego bajtu konfiguracji
    '    Maska bitowa pierwszego bajtu konfiguracji
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_PassConfigSet(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal PNr As Byte, ByVal Config0 As Byte, ByVal Config1 As Byte)
        Dim InKey, Res As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        OutDataA(0) = Config0
        OutDataA(1) = Config1

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_PASS_SET_CONFIG
        OutDataB(TVTTD_PARAM1) = PNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))

        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja kasuje bity w dwuch bajtach konfiguracji hasa
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer hasa do zapisania konfiguracji
    '    Maska bitowa pierwszego bajtu konfiguracji
    '    Maska bitowa pierwszego bajtu konfiguracji
    'Wy
    '        ustawiony("LastError")
    '*****************************************************************************
    Public Sub TVTTAPI_PassConfigClear(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal PNr As Byte, ByVal Config0 As Byte, ByVal Config1 As Byte)
        Dim InKey, Res As Long
        Dim OutDataA(15) As Byte
        Dim OutDataB(15) As Byte
        Dim InDataA(15) As Byte
        Dim InDataB(15) As Byte
        Dim Key As CTVTTAPI_Key

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Exit Sub
        End If

        TVTTAPI_Int_DecodeCon(Pass, Con)

        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        OutDataA(0) = Config0
        OutDataA(1) = Config1

        Con.OutKey = Con.OutKey + 1
        OutDataB(TVTTD_CMD) = TVTTC_PASS_CLR_CONFIG
        OutDataB(TVTTD_PARAM1) = PNr

        TVTT_CalcAuth(OutDataA, OutDataB)
        Key = New CTVTTAPI_Key(Con)
        TVTT_CryptBlock(OutDataA, Con.OutKey, Key.Data, TVTT_BLOCK_A, TVTT_PC2T)
        TVTT_CryptBlock(OutDataB, Con.OutKey, Key.Data, TVTT_BLOCK_B, TVTT_PC2T)
        Res = TVTT_Talk(Con.hToken, 5, Con.OutKey, OutDataA(0), OutDataB(0), InKey, InDataA(0), InDataB(0))

        TVTT_CryptBlock(InDataA, InKey, Key.Data, TVTT_BLOCK_A, TVTT_T2PC)
        TVTT_CryptBlock(InDataB, InKey, Key.Data, TVTT_BLOCK_B, TVTT_T2PC)
        Key.Free()
        If TVTTAPI_Int_CheckError(Con, Res, InKey, InDataA, InDataB) <> 0 Then
            InKey = 0
            ZeroMemory(OutDataA, 16, 0)
            ZeroMemory(OutDataB, 16, 0)
            ZeroMemory(InDataA, 16, 0)
            ZeroMemory(InDataB, 16, 0)
            TVTTAPI_Int_CodeCon(Pass, Con)
            Exit Sub
        End If

        TVTTAPI_Int_CodeCon(Pass, Con)

        InKey = 0
        ZeroMemory(OutDataA, 16, 0)
        ZeroMemory(OutDataB, 16, 0)
        ZeroMemory(InDataA, 16, 0)
        ZeroMemory(InDataB, 16, 0)

        SetLastError(ERROR_SUCCESS)
    End Sub

    '*****************************************************************************
    'Funkcja oblicza wielko tablicy potrzebnej na dane po zaszyfrowaniu
    'We
    '    Rozmiar tablicy do zaszyfrowania
    'Wy
    '    Rozmiar tablicy po zaszyfrowaniu
    '*****************************************************************************
    Function TVTTAPI_EncryptBlockSize(ByVal Size As Integer) As Integer
        Dim Res As Long

        Res = Size \ 16
        If (Size Mod 16) > 0 Then Res = Res + 1
        Res = Res + 4
        Return Res * 16
    End Function

    '*****************************************************************************
    'Funkcja szyfruje blok danych o dowolnym rozmiarze
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer hasa do szyfrowania
    '    Tablica z danymi
    '    Ilo danych do zaszyfrowania
    '    Adres na zmienn do ktrej zostanie wpisana ilo danych po zaszyfrowaniu
    'Wy
    '    True jesli operacja sie powioda, w przeciwnym wypadku False
    '    Rozmiar bloku zaszyfrowanego (przez byref OSize)
    '        ustawiony("LastError")
    '*****************************************************************************
    Function TVTTAPI_EncryptBlock(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal PNr As Byte, ByRef Buff() As Byte, ByVal Size As Integer, ByRef OSize As Integer) As Boolean
        Dim n, i As Integer
        Dim Key(15) As Byte


        If (Pass Is Nothing) Or (Con Is Nothing) Or (Buff Is Nothing) Or (Size <= 64) Then
            SetLastError(ERROR_INVALID_DATA)
            Return False
        End If

        OSize = TVTTAPI_EncryptBlockSize(Size)

        CopyTable(Buff, Buff, 64, 0, Size)
        TVTT_Rand(Buff, 0)
        TVTT_Rand(Buff, 2 * 16)
        TVTT_Rand(Buff, 3 * 16)

        Buff(16 + 0) = (Size And &HFF)
        Buff(16 + 1) = ((Size \ &H100) And &HFF)
        Buff(16 + 2) = ((Size \ &H10000) And &HFF)
        Buff(16 + 3) = ((Size \ &H1000000) And &HFF)

        Buff(16 + 4) = (OSize And &HFF)
        Buff(16 + 5) = ((OSize \ &H100) And &HFF)
        Buff(16 + 6) = ((OSize \ &H10000) And &HFF)
        Buff(16 + 7) = ((OSize \ &H1000000) And &HFF)

        CopyTable(Key, Buff, 0, 0, 16)
        TVTTAPI_Encrypt(Pass, Con, PNr, Key)
        If Err.LastDllError <> ERROR_SUCCESS Then
            ZeroMemory(Buff, OSize, 0)
            OSize = 0
            Return False
        End If

        rijndaelEncrypt(Key, 0, Buff, 16)

        CopyTable(Key, Buff, 0, 2 * 16, 16)
        TVTTAPI_Encrypt(Pass, Con, PNr, Key)
        If Err.LastDllError <> ERROR_SUCCESS Then
            ZeroMemory(Buff, OSize, 0)
            OSize = 0
            Return False
        End If

        n = 4 * 16
        While n < OSize

            i = 0
            While i < 16

                Buff(n + i) = (Buff(n + i) Xor Buff(n + i - 16)) And &HFF
                i = i + 1
            End While
            rijndaelEncrypt(Key, 0, Buff, n)
            n = n + 16
        End While

        SetLastError(ERROR_SUCCESS)
        Return True
    End Function

    '*****************************************************************************
    'Funkcja rozszyfruje wczeniej zaszyfrowany blok danych o dowolnym rozmiarze
    'We
    '    Adres na 16-bajtowy klucz do poczenia
    '        Obiekt(poczenia)
    '    Numer hasa do szyfrowania
    '    Tablica z danymi
    '    Ilo danych do rozszyfrowania
    '    Adres na zmienn do ktrej zostanie wpisana ilo danych po rozszyfrowaniu
    'Wy
    '    True jesli operacja sie powioda, w przeciwnym wypadku False
    '    Rozmiar bloku rozszyfrowanego (przez byref OSize)
    '        ustawiony("LastError")
    '*****************************************************************************
    Function TVTTAPI_DecryptBlock(ByVal Pass() As Byte, ByRef Con As CTVTTAPI_INT_CON, ByVal PNr As Byte, ByRef Buff() As Byte, ByRef OSize As Integer) As Boolean
        Dim n, i, TSize As Integer
        Dim Key(15) As Byte
        Dim Tmp(15) As Byte
        Dim TBuff() As Byte

        If (Pass Is Nothing) Or (Con Is Nothing) Then
            SetLastError(ERROR_INVALID_DATA)
            Return False
        End If

        CopyTable(Key, Buff, 0, 0, 16)
        TVTTAPI_Encrypt(Pass, Con, PNr, Key)
        If Err.LastDllError <> ERROR_SUCCESS Then
            ZeroMemory(Key, 16, 0)
            Return False
        End If

        CopyTable(Tmp, Buff, 0, 16, 16)
        rijndaelDecrypt(Key, 0, Tmp, 0)

        TSize = Tmp(7)
        TSize = TSize * &H100
        TSize = TSize Or Tmp(6)
        TSize = TSize * &H100
        TSize = TSize Or Tmp(5)
        TSize = TSize * &H100
        TSize = TSize Or Tmp(4)

        OSize = Tmp(3)
        OSize = OSize * &H100
        OSize = OSize Or Tmp(2)
        OSize = OSize * &H100
        OSize = OSize Or Tmp(1)
        OSize = OSize * &H100
        OSize = OSize Or Tmp(0)

        ReDim TBuff(TSize - (3 * 16))
        CopyTable(TBuff, Buff, 0, 3 * 16, TSize - (3 * 16))
        CopyTable(Key, Buff, 0, 2 * 16, 16)
        TVTTAPI_Encrypt(Pass, Con, PNr, Key)
        If Err.LastDllError <> ERROR_SUCCESS Then
            ZeroMemory(Buff, OSize, 0)
            ZeroMemory(TBuff, TSize - (3 * 16), 0)
            ZeroMemory(Key, 16, 0)
            ZeroMemory(Tmp, 16, 0)
            TSize = 0
            ' ominicie optymalizacji kodu przez kompilator
            Tmp(0) = TSize
            Return False
        End If

        n = TSize - (3 * 16) - 16
        While n > 15
            rijndaelDecrypt(Key, 0, TBuff, n)
            i = 0
            While i < 16
                TBuff(n + i) = TBuff(n + i) Xor TBuff(n + i - 16)
                i = i + 1
            End While
            n = n - 16
        End While

        CopyTable(Buff, TBuff, 0, 16, OSize)
        ZeroMemory(TBuff, TSize - (3 * 16), 0)

        SetLastError(ERROR_SUCCESS)
        Return True
    End Function

end module
